/* Startup.c generated by valac 0.56.17, the Vala compiler
 * generated from Startup.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2013-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Akshay Shekher <voldyman666@gmail.com>
 *              Julien Spautz <spautz.julien@gmail.com>
 */

#include "applications.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <granite-7.h>
#include <switchboard.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	STARTUP_PLUG_0_PROPERTY,
	STARTUP_PLUG_NUM_PROPERTIES
};
static GParamSpec* startup_plug_properties[STARTUP_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GdkFileList_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkFileList_free (var), NULL)))

struct _StartupPlugPrivate {
	StartupController* controller;
	GtkListBox* list;
	StartupWidgetsAppChooser* app_chooser;
};

struct _Block2Data {
	int _ref_count_;
	StartupPlug* self;
	StartupBackendKeyFile* key_file;
};

static gint StartupPlug_private_offset;
static gpointer startup_plug_parent_class = NULL;

static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda24_ (Block2Data* _data2_,
                  gboolean active);
static void ___lambda24__startup_widgets_app_row_active_changed (StartupWidgetsAppRow* _sender,
                                                          gboolean active,
                                                          gpointer self);
static void startup_plug_create_file (StartupPlug* self,
                               const gchar* path);
VALA_EXTERN StartupBackendKeyFile* startup_backend_key_file_factory_get_or_create (const gchar* path);
static gchar* startup_plug_get_path_from_uri (StartupPlug* self,
                                       const gchar* uri);
static gint startup_plug_sort_function (StartupPlug* self,
                                 GtkListBoxRow* row1,
                                 GtkListBoxRow* row2);
static gboolean startup_plug_on_drag_data_received (StartupPlug* self,
                                             GtkDropTarget* drop_target,
                                             GValue* val,
                                             gdouble x,
                                             gdouble y);
static GdkFileList* _vala_GdkFileList_copy (GdkFileList* self);
static void _vala_GdkFileList_free (GdkFileList* self);
static GObject * startup_plug_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
VALA_EXTERN void startup_backend_key_file_factory_init (void);
static gint _startup_plug_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                         GtkListBoxRow* row2,
                                                         gpointer self);
static void _startup_plug___lambda26_ (StartupPlug* self);
static void __startup_plug___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void _startup_plug___lambda27_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda27__startup_widgets_app_chooser_app_chosen (StartupWidgetsAppChooser* _sender,
                                                                        const gchar* path,
                                                                        gpointer self);
static void _startup_plug___lambda28_ (StartupPlug* self,
                                const gchar* command);
static void __startup_plug___lambda28__startup_widgets_app_chooser_custom_command_chosen (StartupWidgetsAppChooser* _sender,
                                                                                   const gchar* command,
                                                                                   gpointer self);
static gboolean _startup_plug_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                   GValue* value,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void _startup_plug___lambda29_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda29__startup_backend_monitor_file_created (StartupBackendMonitor* _sender,
                                                                      const gchar* path,
                                                                      gpointer self);
static void _startup_plug___lambda30_ (StartupPlug* self,
                                const gchar* path);
static void __startup_plug___lambda30__startup_backend_monitor_file_deleted (StartupBackendMonitor* _sender,
                                                                      const gchar* path,
                                                                      gpointer self);
static void startup_plug_finalize (GObject * obj);
static GType startup_plug_get_type_once (void);

static inline gpointer
startup_plug_get_instance_private (StartupPlug* self)
{
	return G_STRUCT_MEMBER_P (self, StartupPlug_private_offset);
}

StartupPlug*
startup_plug_construct (GType object_type)
{
	StartupPlug * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 15 "../src/Startup/Startup.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("preferences-desktop-startup");
#line 15 "../src/Startup/Startup.vala"
	_tmp1_ = _tmp0_;
#line 15 "../src/Startup/Startup.vala"
	self = (StartupPlug*) g_object_new (object_type, "title", _ ("Startup"), "icon", _tmp1_, NULL);
#line 15 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp1_);
#line 14 "../src/Startup/Startup.vala"
	return self;
#line 145 "Startup.c"
}

StartupPlug*
startup_plug_new (void)
{
#line 14 "../src/Startup/Startup.vala"
	return startup_plug_construct (STARTUP_TYPE_PLUG);
#line 153 "Startup.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "../src/Startup/Startup.vala"
	return self ? g_object_ref (self) : NULL;
#line 161 "Startup.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 101 "../src/Startup/Startup.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 101 "../src/Startup/Startup.vala"
	return _data2_;
#line 171 "Startup.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 101 "../src/Startup/Startup.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 181 "Startup.c"
		StartupPlug* self;
#line 101 "../src/Startup/Startup.vala"
		self = _data2_->self;
#line 101 "../src/Startup/Startup.vala"
		_g_object_unref0 (_data2_->key_file);
#line 101 "../src/Startup/Startup.vala"
		_g_object_unref0 (self);
#line 101 "../src/Startup/Startup.vala"
		g_slice_free (Block2Data, _data2_);
#line 191 "Startup.c"
	}
}

static void
__lambda24_ (Block2Data* _data2_,
             gboolean active)
{
	StartupPlug* self;
#line 116 "../src/Startup/Startup.vala"
	self = _data2_->self;
#line 117 "../src/Startup/Startup.vala"
	startup_backend_key_file_set_active (_data2_->key_file, active);
#line 118 "../src/Startup/Startup.vala"
	startup_backend_key_file_write_to_file (_data2_->key_file);
#line 206 "Startup.c"
}

static void
___lambda24__startup_widgets_app_row_active_changed (StartupWidgetsAppRow* _sender,
                                                     gboolean active,
                                                     gpointer self)
{
#line 116 "../src/Startup/Startup.vala"
	__lambda24_ (self, active);
#line 216 "Startup.c"
}

void
startup_plug_add_app (StartupPlug* self,
                      StartupBackendKeyFile* key_file)
{
	Block2Data* _data2_;
	StartupBackendKeyFile* _tmp0_;
	StartupEntityAppInfo app_info = {0};
	StartupEntityAppInfo _tmp1_ = {0};
	GtkWidget* child = NULL;
	GtkListBox* _tmp2_;
	GtkWidget* _tmp3_;
	StartupWidgetsAppRow* row = NULL;
	StartupEntityAppInfo _tmp13_;
	StartupWidgetsAppRow* _tmp14_;
	GtkListBox* _tmp15_;
	StartupWidgetsAppRow* _tmp16_;
	StartupWidgetsAppRow* _tmp17_;
#line 101 "../src/Startup/Startup.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/Startup/Startup.vala"
	g_return_if_fail (key_file != NULL);
#line 101 "../src/Startup/Startup.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 101 "../src/Startup/Startup.vala"
	_data2_->_ref_count_ = 1;
#line 101 "../src/Startup/Startup.vala"
	_data2_->self = g_object_ref (self);
#line 101 "../src/Startup/Startup.vala"
	_tmp0_ = _g_object_ref0 (key_file);
#line 101 "../src/Startup/Startup.vala"
	_g_object_unref0 (_data2_->key_file);
#line 101 "../src/Startup/Startup.vala"
	_data2_->key_file = _tmp0_;
#line 102 "../src/Startup/Startup.vala"
	startup_backend_key_file_create_app_info (_data2_->key_file, &_tmp1_);
#line 102 "../src/Startup/Startup.vala"
	app_info = _tmp1_;
#line 104 "../src/Startup/Startup.vala"
	_tmp2_ = self->priv->list;
#line 104 "../src/Startup/Startup.vala"
	_tmp3_ = gtk_widget_get_first_child ((GtkWidget*) _tmp2_);
#line 104 "../src/Startup/Startup.vala"
	child = _tmp3_;
#line 105 "../src/Startup/Startup.vala"
	while (TRUE) {
#line 264 "Startup.c"
		GtkWidget* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
#line 105 "../src/Startup/Startup.vala"
		_tmp4_ = child;
#line 105 "../src/Startup/Startup.vala"
		if (!(_tmp4_ != NULL)) {
#line 105 "../src/Startup/Startup.vala"
			break;
#line 276 "Startup.c"
		}
#line 106 "../src/Startup/Startup.vala"
		_tmp6_ = child;
#line 106 "../src/Startup/Startup.vala"
		if (STARTUP_WIDGETS_IS_APP_ROW (_tmp6_)) {
#line 282 "Startup.c"
			GtkWidget* _tmp7_;
			StartupEntityAppInfo _tmp8_ = {0};
			StartupEntityAppInfo _tmp9_;
			StartupEntityAppInfo _tmp10_;
#line 106 "../src/Startup/Startup.vala"
			_tmp7_ = child;
#line 106 "../src/Startup/Startup.vala"
			startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp8_);
#line 106 "../src/Startup/Startup.vala"
			_tmp9_ = _tmp8_;
#line 106 "../src/Startup/Startup.vala"
			_tmp10_ = app_info;
#line 106 "../src/Startup/Startup.vala"
			_tmp5_ = startup_entity_app_info_equal (&_tmp9_, &_tmp10_);
#line 297 "Startup.c"
		} else {
#line 106 "../src/Startup/Startup.vala"
			_tmp5_ = FALSE;
#line 301 "Startup.c"
		}
#line 106 "../src/Startup/Startup.vala"
		if (_tmp5_) {
#line 107 "../src/Startup/Startup.vala"
			startup_entity_app_info_destroy (&app_info);
#line 107 "../src/Startup/Startup.vala"
			block2_data_unref (_data2_);
#line 107 "../src/Startup/Startup.vala"
			_data2_ = NULL;
#line 107 "../src/Startup/Startup.vala"
			return;
#line 313 "Startup.c"
		}
#line 110 "../src/Startup/Startup.vala"
		_tmp11_ = child;
#line 110 "../src/Startup/Startup.vala"
		_tmp12_ = gtk_widget_get_next_sibling (_tmp11_);
#line 110 "../src/Startup/Startup.vala"
		child = _tmp12_;
#line 321 "Startup.c"
	}
#line 113 "../src/Startup/Startup.vala"
	_tmp13_ = app_info;
#line 113 "../src/Startup/Startup.vala"
	_tmp14_ = startup_widgets_app_row_new (&_tmp13_);
#line 113 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp14_);
#line 113 "../src/Startup/Startup.vala"
	row = _tmp14_;
#line 114 "../src/Startup/Startup.vala"
	_tmp15_ = self->priv->list;
#line 114 "../src/Startup/Startup.vala"
	_tmp16_ = row;
#line 114 "../src/Startup/Startup.vala"
	gtk_list_box_append (_tmp15_, (GtkWidget*) _tmp16_);
#line 116 "../src/Startup/Startup.vala"
	_tmp17_ = row;
#line 116 "../src/Startup/Startup.vala"
	g_signal_connect_data (_tmp17_, "active-changed", (GCallback) ___lambda24__startup_widgets_app_row_active_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 101 "../src/Startup/Startup.vala"
	_g_object_unref0 (row);
#line 101 "../src/Startup/Startup.vala"
	startup_entity_app_info_destroy (&app_info);
#line 101 "../src/Startup/Startup.vala"
	block2_data_unref (_data2_);
#line 101 "../src/Startup/Startup.vala"
	_data2_ = NULL;
#line 349 "Startup.c"
}

void
startup_plug_remove_app_from_path (StartupPlug* self,
                                   const gchar* path)
{
	GtkWidget* child = NULL;
	GtkListBox* _tmp0_;
	GtkWidget* _tmp1_;
#line 122 "../src/Startup/Startup.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Startup/Startup.vala"
	g_return_if_fail (path != NULL);
#line 123 "../src/Startup/Startup.vala"
	_tmp0_ = self->priv->list;
#line 123 "../src/Startup/Startup.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 123 "../src/Startup/Startup.vala"
	child = _tmp1_;
#line 124 "../src/Startup/Startup.vala"
	while (TRUE) {
#line 371 "Startup.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
#line 124 "../src/Startup/Startup.vala"
		_tmp2_ = child;
#line 124 "../src/Startup/Startup.vala"
		if (!(_tmp2_ != NULL)) {
#line 124 "../src/Startup/Startup.vala"
			break;
#line 383 "Startup.c"
		}
#line 125 "../src/Startup/Startup.vala"
		_tmp4_ = child;
#line 125 "../src/Startup/Startup.vala"
		if (STARTUP_WIDGETS_IS_APP_ROW (_tmp4_)) {
#line 389 "Startup.c"
			GtkWidget* _tmp5_;
			StartupEntityAppInfo _tmp6_ = {0};
			StartupEntityAppInfo _tmp7_;
			const gchar* _tmp8_;
#line 125 "../src/Startup/Startup.vala"
			_tmp5_ = child;
#line 125 "../src/Startup/Startup.vala"
			startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp6_);
#line 125 "../src/Startup/Startup.vala"
			_tmp7_ = _tmp6_;
#line 125 "../src/Startup/Startup.vala"
			_tmp8_ = _tmp7_.path;
#line 125 "../src/Startup/Startup.vala"
			_tmp3_ = g_strcmp0 (_tmp8_, path) == 0;
#line 404 "Startup.c"
		} else {
#line 125 "../src/Startup/Startup.vala"
			_tmp3_ = FALSE;
#line 408 "Startup.c"
		}
#line 125 "../src/Startup/Startup.vala"
		if (_tmp3_) {
#line 412 "Startup.c"
			GtkListBox* _tmp9_;
			GtkWidget* _tmp10_;
#line 126 "../src/Startup/Startup.vala"
			_tmp9_ = self->priv->list;
#line 126 "../src/Startup/Startup.vala"
			_tmp10_ = child;
#line 126 "../src/Startup/Startup.vala"
			gtk_list_box_remove (_tmp9_, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow));
#line 127 "../src/Startup/Startup.vala"
			return;
#line 423 "Startup.c"
		}
#line 130 "../src/Startup/Startup.vala"
		_tmp11_ = child;
#line 130 "../src/Startup/Startup.vala"
		_tmp12_ = gtk_widget_get_next_sibling (_tmp11_);
#line 130 "../src/Startup/Startup.vala"
		child = _tmp12_;
#line 431 "Startup.c"
	}
}

void
startup_plug_init_app_chooser (StartupPlug* self,
                               GeeCollection* app_infos)
{
	StartupWidgetsAppChooser* _tmp0_;
#line 134 "../src/Startup/Startup.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Startup/Startup.vala"
	g_return_if_fail (app_infos != NULL);
#line 135 "../src/Startup/Startup.vala"
	_tmp0_ = self->priv->app_chooser;
#line 135 "../src/Startup/Startup.vala"
	startup_widgets_app_chooser_init_list (_tmp0_, app_infos);
#line 448 "Startup.c"
}

static void
startup_plug_create_file (StartupPlug* self,
                          const gchar* path)
{
	StartupBackendKeyFile* key_file = NULL;
	StartupBackendKeyFile* _tmp0_;
#line 138 "../src/Startup/Startup.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/Startup/Startup.vala"
	g_return_if_fail (path != NULL);
#line 139 "../src/Startup/Startup.vala"
	_tmp0_ = startup_backend_key_file_factory_get_or_create (path);
#line 139 "../src/Startup/Startup.vala"
	key_file = _tmp0_;
#line 140 "../src/Startup/Startup.vala"
	startup_backend_key_file_set_active (key_file, TRUE);
#line 141 "../src/Startup/Startup.vala"
	startup_backend_key_file_copy_to_local (key_file);
#line 143 "../src/Startup/Startup.vala"
	startup_plug_add_app (self, key_file);
#line 138 "../src/Startup/Startup.vala"
	_g_object_unref0 (key_file);
#line 473 "Startup.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 494 "Startup.c"
}

static gchar*
startup_plug_get_path_from_uri (StartupPlug* self,
                                const gchar* uri)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 146 "../src/Startup/Startup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "../src/Startup/Startup.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 147 "../src/Startup/Startup.vala"
	if (g_str_has_prefix (uri, "#")) {
#line 147 "../src/Startup/Startup.vala"
		_tmp0_ = TRUE;
#line 512 "Startup.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 147 "../src/Startup/Startup.vala"
		_tmp1_ = string_strip (uri);
#line 147 "../src/Startup/Startup.vala"
		_tmp2_ = _tmp1_;
#line 147 "../src/Startup/Startup.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 147 "../src/Startup/Startup.vala"
		_g_free0 (_tmp2_);
#line 524 "Startup.c"
	}
#line 147 "../src/Startup/Startup.vala"
	if (_tmp0_) {
#line 148 "../src/Startup/Startup.vala"
		result = NULL;
#line 148 "../src/Startup/Startup.vala"
		return result;
#line 532 "Startup.c"
	}
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 151 "../src/Startup/Startup.vala"
		_tmp4_ = g_filename_from_uri (uri, NULL, &_inner_error0_);
#line 151 "../src/Startup/Startup.vala"
		_tmp3_ = _tmp4_;
#line 151 "../src/Startup/Startup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 544 "Startup.c"
			goto __catch0_g_error;
		}
#line 151 "../src/Startup/Startup.vala"
		_tmp5_ = _tmp3_;
#line 151 "../src/Startup/Startup.vala"
		_tmp3_ = NULL;
#line 151 "../src/Startup/Startup.vala"
		result = _tmp5_;
#line 151 "../src/Startup/Startup.vala"
		_g_free0 (_tmp3_);
#line 151 "../src/Startup/Startup.vala"
		return result;
#line 557 "Startup.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 150 "../src/Startup/Startup.vala"
		e = _inner_error0_;
#line 150 "../src/Startup/Startup.vala"
		_inner_error0_ = NULL;
#line 153 "../src/Startup/Startup.vala"
		g_warning ("Startup.vala:153: Could not convert URI of dropped item to filename");
#line 154 "../src/Startup/Startup.vala"
		_tmp6_ = e;
#line 154 "../src/Startup/Startup.vala"
		_tmp7_ = _tmp6_->message;
#line 154 "../src/Startup/Startup.vala"
		g_warning ("Startup.vala:154: %s", _tmp7_);
#line 150 "../src/Startup/Startup.vala"
		_g_error_free0 (e);
#line 579 "Startup.c"
	}
	__finally0:
#line 150 "../src/Startup/Startup.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/Startup/Startup.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/Startup/Startup.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../src/Startup/Startup.vala"
		return NULL;
#line 590 "Startup.c"
	}
#line 157 "../src/Startup/Startup.vala"
	result = NULL;
#line 157 "../src/Startup/Startup.vala"
	return result;
#line 596 "Startup.c"
}

static gint
startup_plug_sort_function (StartupPlug* self,
                            GtkListBoxRow* row1,
                            GtkListBoxRow* row2)
{
	gchar* name_1 = NULL;
	StartupEntityAppInfo _tmp0_ = {0};
	StartupEntityAppInfo _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* name_2 = NULL;
	StartupEntityAppInfo _tmp4_ = {0};
	StartupEntityAppInfo _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gint result;
#line 160 "../src/Startup/Startup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 160 "../src/Startup/Startup.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 160 "../src/Startup/Startup.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 161 "../src/Startup/Startup.vala"
	startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (row1, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp0_);
#line 161 "../src/Startup/Startup.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/Startup/Startup.vala"
	_tmp2_ = _tmp1_.name;
#line 161 "../src/Startup/Startup.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 161 "../src/Startup/Startup.vala"
	name_1 = _tmp3_;
#line 162 "../src/Startup/Startup.vala"
	startup_widgets_app_row_get_app_info (G_TYPE_CHECK_INSTANCE_CAST (row2, STARTUP_WIDGETS_TYPE_APP_ROW, StartupWidgetsAppRow), &_tmp4_);
#line 162 "../src/Startup/Startup.vala"
	_tmp5_ = _tmp4_;
#line 162 "../src/Startup/Startup.vala"
	_tmp6_ = _tmp5_.name;
#line 162 "../src/Startup/Startup.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 162 "../src/Startup/Startup.vala"
	name_2 = _tmp7_;
#line 164 "../src/Startup/Startup.vala"
	result = g_utf8_collate (name_1, name_2);
#line 164 "../src/Startup/Startup.vala"
	_g_free0 (name_2);
#line 164 "../src/Startup/Startup.vala"
	_g_free0 (name_1);
#line 164 "../src/Startup/Startup.vala"
	return result;
#line 649 "Startup.c"
}

static GdkFileList*
_vala_GdkFileList_copy (GdkFileList* self)
{
#line 168 "../src/Startup/Startup.vala"
	return g_boxed_copy (gdk_file_list_get_type (), self);
#line 657 "Startup.c"
}

static gpointer
__vala_GdkFileList_copy0 (gpointer self)
{
#line 168 "../src/Startup/Startup.vala"
	return self ? _vala_GdkFileList_copy (self) : NULL;
#line 665 "Startup.c"
}

static void
_vala_GdkFileList_free (GdkFileList* self)
{
#line 178 "../src/Startup/Startup.vala"
	g_boxed_free (gdk_file_list_get_type (), self);
#line 673 "Startup.c"
}

static gboolean
startup_plug_on_drag_data_received (StartupPlug* self,
                                    GtkDropTarget* drop_target,
                                    GValue* val,
                                    gdouble x,
                                    gdouble y)
{
	GdkFileList* file_list = NULL;
	GValue _tmp0_;
	GdkFileList* _tmp1_;
	GSList* files = NULL;
	GdkFileList* _tmp2_;
	GSList* _tmp3_;
	GSList* _tmp4_;
	gboolean result;
#line 167 "../src/Startup/Startup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 167 "../src/Startup/Startup.vala"
	g_return_val_if_fail (drop_target != NULL, FALSE);
#line 167 "../src/Startup/Startup.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 168 "../src/Startup/Startup.vala"
	_tmp0_ = *val;
#line 168 "../src/Startup/Startup.vala"
	_tmp1_ = __vala_GdkFileList_copy0 (g_value_get_boxed (&_tmp0_));
#line 168 "../src/Startup/Startup.vala"
	file_list = _tmp1_;
#line 169 "../src/Startup/Startup.vala"
	_tmp2_ = file_list;
#line 169 "../src/Startup/Startup.vala"
	_tmp3_ = gdk_file_list_get_files (_tmp2_);
#line 169 "../src/Startup/Startup.vala"
	files = _tmp3_;
#line 171 "../src/Startup/Startup.vala"
	_tmp4_ = files;
#line 711 "Startup.c"
	{
		GSList* file_collection = NULL;
		GSList* file_it = NULL;
#line 171 "../src/Startup/Startup.vala"
		file_collection = _tmp4_;
#line 171 "../src/Startup/Startup.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 719 "Startup.c"
			GFile* file = NULL;
#line 171 "../src/Startup/Startup.vala"
			file = (GFile*) file_it->data;
#line 723 "Startup.c"
			{
				gchar* path = NULL;
				GFile* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
#line 172 "../src/Startup/Startup.vala"
				_tmp5_ = file;
#line 172 "../src/Startup/Startup.vala"
				_tmp6_ = g_file_get_path (_tmp5_);
#line 172 "../src/Startup/Startup.vala"
				path = _tmp6_;
#line 173 "../src/Startup/Startup.vala"
				_tmp7_ = path;
#line 173 "../src/Startup/Startup.vala"
				if (_tmp7_ != NULL) {
#line 739 "Startup.c"
					const gchar* _tmp8_;
#line 174 "../src/Startup/Startup.vala"
					_tmp8_ = path;
#line 174 "../src/Startup/Startup.vala"
					startup_plug_create_file (self, _tmp8_);
#line 745 "Startup.c"
				}
#line 171 "../src/Startup/Startup.vala"
				_g_free0 (path);
#line 749 "Startup.c"
			}
		}
	}
#line 178 "../src/Startup/Startup.vala"
	result = FALSE;
#line 178 "../src/Startup/Startup.vala"
	(files == NULL) ? NULL : (files = (g_slist_free (files), NULL));
#line 178 "../src/Startup/Startup.vala"
	__vala_GdkFileList_free0 (file_list);
#line 178 "../src/Startup/Startup.vala"
	return result;
#line 761 "Startup.c"
}

static gint
_startup_plug_sort_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                    GtkListBoxRow* row2,
                                                    gpointer self)
{
	gint result;
	result = startup_plug_sort_function ((StartupPlug*) self, row1, row2);
#line 34 "../src/Startup/Startup.vala"
	return result;
#line 773 "Startup.c"
}

static void
_startup_plug___lambda26_ (StartupPlug* self)
{
	StartupWidgetsAppChooser* _tmp0_;
	GtkRoot* _tmp1_;
	StartupWidgetsAppChooser* _tmp2_;
#line 78 "../src/Startup/Startup.vala"
	_tmp0_ = self->priv->app_chooser;
#line 78 "../src/Startup/Startup.vala"
	_tmp1_ = gtk_widget_get_root ((GtkWidget*) self);
#line 78 "../src/Startup/Startup.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 79 "../src/Startup/Startup.vala"
	_tmp2_ = self->priv->app_chooser;
#line 79 "../src/Startup/Startup.vala"
	gtk_window_present ((GtkWindow*) _tmp2_);
#line 792 "Startup.c"
}

static void
__startup_plug___lambda26__gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
#line 76 "../src/Startup/Startup.vala"
	_startup_plug___lambda26_ ((StartupPlug*) self);
#line 801 "Startup.c"
}

static void
_startup_plug___lambda27_ (StartupPlug* self,
                           const gchar* path)
{
#line 82 "../src/Startup/Startup.vala"
	g_return_if_fail (path != NULL);
#line 83 "../src/Startup/Startup.vala"
	startup_plug_create_file (self, path);
#line 812 "Startup.c"
}

static void
__startup_plug___lambda27__startup_widgets_app_chooser_app_chosen (StartupWidgetsAppChooser* _sender,
                                                                   const gchar* path,
                                                                   gpointer self)
{
#line 82 "../src/Startup/Startup.vala"
	_startup_plug___lambda27_ ((StartupPlug*) self, path);
#line 822 "Startup.c"
}

static void
_startup_plug___lambda28_ (StartupPlug* self,
                           const gchar* command)
{
	StartupBackendKeyFile* _tmp0_;
	StartupBackendKeyFile* _tmp1_;
#line 86 "../src/Startup/Startup.vala"
	g_return_if_fail (command != NULL);
#line 87 "../src/Startup/Startup.vala"
	_tmp0_ = startup_backend_key_file_new_from_command (command);
#line 87 "../src/Startup/Startup.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/Startup/Startup.vala"
	startup_plug_add_app (self, _tmp1_);
#line 87 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp1_);
#line 841 "Startup.c"
}

static void
__startup_plug___lambda28__startup_widgets_app_chooser_custom_command_chosen (StartupWidgetsAppChooser* _sender,
                                                                              const gchar* command,
                                                                              gpointer self)
{
#line 86 "../src/Startup/Startup.vala"
	_startup_plug___lambda28_ ((StartupPlug*) self, command);
#line 851 "Startup.c"
}

static gboolean
_startup_plug_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                          GValue* value,
                                                          gdouble x,
                                                          gdouble y,
                                                          gpointer self)
{
	gboolean result;
	result = startup_plug_on_drag_data_received ((StartupPlug*) self, _sender, value, x, y);
#line 90 "../src/Startup/Startup.vala"
	return result;
#line 865 "Startup.c"
}

static void
_startup_plug___lambda29_ (StartupPlug* self,
                           const gchar* path)
{
	StartupBackendKeyFile* _tmp0_;
	StartupBackendKeyFile* _tmp1_;
#line 92 "../src/Startup/Startup.vala"
	g_return_if_fail (path != NULL);
#line 93 "../src/Startup/Startup.vala"
	_tmp0_ = startup_backend_key_file_factory_get_or_create (path);
#line 93 "../src/Startup/Startup.vala"
	_tmp1_ = _tmp0_;
#line 93 "../src/Startup/Startup.vala"
	startup_plug_add_app (self, _tmp1_);
#line 93 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp1_);
#line 884 "Startup.c"
}

static void
__startup_plug___lambda29__startup_backend_monitor_file_created (StartupBackendMonitor* _sender,
                                                                 const gchar* path,
                                                                 gpointer self)
{
#line 92 "../src/Startup/Startup.vala"
	_startup_plug___lambda29_ ((StartupPlug*) self, path);
#line 894 "Startup.c"
}

static void
_startup_plug___lambda30_ (StartupPlug* self,
                           const gchar* path)
{
#line 96 "../src/Startup/Startup.vala"
	g_return_if_fail (path != NULL);
#line 97 "../src/Startup/Startup.vala"
	startup_plug_remove_app_from_path (self, path);
#line 905 "Startup.c"
}

static void
__startup_plug___lambda30__startup_backend_monitor_file_deleted (StartupBackendMonitor* _sender,
                                                                 const gchar* path,
                                                                 gpointer self)
{
#line 96 "../src/Startup/Startup.vala"
	_startup_plug___lambda30_ ((StartupPlug*) self, path);
#line 915 "Startup.c"
}

static GObject *
startup_plug_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	StartupPlug * self;
	GranitePlaceholder* empty_alert = NULL;
	gchar* _tmp0_;
	GranitePlaceholder* _tmp1_ = NULL;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GranitePlaceholder* _tmp5_;
	GtkListBox* _tmp6_;
	GtkDropTarget* drop_target = NULL;
	GtkDropTarget* _tmp7_;
	GtkListBox* _tmp8_;
	GtkDropTarget* _tmp9_;
	GtkEventController* _tmp10_;
	GtkScrolledWindow* scrolled = NULL;
	GtkListBox* _tmp11_;
	GtkWidget* _tmp12_;
	GtkScrolledWindow* _tmp13_ = NULL;
	GtkBox* add_button_box = NULL;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkBox* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkButton* add_button = NULL;
	GtkBox* _tmp21_;
	GtkWidget* _tmp22_;
	GtkButton* _tmp23_ = NULL;
	GtkButton* _tmp24_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp25_;
	GtkActionBar* _tmp26_;
	GtkActionBar* _tmp27_;
	GtkButton* _tmp28_;
	GtkBox* box = NULL;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GtkScrolledWindow* _tmp31_;
	GtkBox* _tmp32_;
	GtkActionBar* _tmp33_;
	GtkFrame* frame = NULL;
	GtkBox* _tmp34_;
	GtkWidget* _tmp35_;
	GtkFrame* _tmp36_ = NULL;
	GtkFrame* _tmp37_;
	StartupWidgetsAppChooser* _tmp38_ = NULL;
	StartupBackendMonitor* monitor = NULL;
	StartupBackendMonitor* _tmp39_;
	StartupController* _tmp40_;
	GtkButton* _tmp41_;
	StartupWidgetsAppChooser* _tmp42_;
	StartupWidgetsAppChooser* _tmp43_;
	GtkDropTarget* _tmp44_;
	StartupBackendMonitor* _tmp45_;
	StartupBackendMonitor* _tmp46_;
#line 21 "../src/Startup/Startup.vala"
	parent_class = G_OBJECT_CLASS (startup_plug_parent_class);
#line 21 "../src/Startup/Startup.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 21 "../src/Startup/Startup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_PLUG, StartupPlug);
#line 22 "../src/Startup/Startup.vala"
	startup_backend_key_file_factory_init ();
#line 24 "../src/Startup/Startup.vala"
	_tmp0_ = g_strdup (_ ("Add apps to the Startup list by clicking the icon in the toolbar below" \
"."));
#line 24 "../src/Startup/Startup.vala"
	_tmp1_ = granite_placeholder_new (_ ("Launch Apps on Startup"));
#line 24 "../src/Startup/Startup.vala"
	granite_placeholder_set_description (_tmp1_, _tmp0_);
#line 24 "../src/Startup/Startup.vala"
	_g_free0 (_tmp0_);
#line 24 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp1_);
#line 24 "../src/Startup/Startup.vala"
	empty_alert = _tmp1_;
#line 28 "../src/Startup/Startup.vala"
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
#line 28 "../src/Startup/Startup.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 28 "../src/Startup/Startup.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
#line 28 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp2_);
#line 28 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->list);
#line 28 "../src/Startup/Startup.vala"
	self->priv->list = _tmp2_;
#line 32 "../src/Startup/Startup.vala"
	_tmp3_ = self->priv->list;
#line 32 "../src/Startup/Startup.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, GRANITE_STYLE_CLASS_RICH_LIST);
#line 33 "../src/Startup/Startup.vala"
	_tmp4_ = self->priv->list;
#line 33 "../src/Startup/Startup.vala"
	_tmp5_ = empty_alert;
#line 33 "../src/Startup/Startup.vala"
	gtk_list_box_set_placeholder (_tmp4_, (GtkWidget*) _tmp5_);
#line 34 "../src/Startup/Startup.vala"
	_tmp6_ = self->priv->list;
#line 34 "../src/Startup/Startup.vala"
	gtk_list_box_set_sort_func (_tmp6_, _startup_plug_sort_function_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 36 "../src/Startup/Startup.vala"
	_tmp7_ = gtk_drop_target_new (gdk_file_list_get_type (), GDK_ACTION_COPY);
#line 36 "../src/Startup/Startup.vala"
	drop_target = _tmp7_;
#line 37 "../src/Startup/Startup.vala"
	_tmp8_ = self->priv->list;
#line 37 "../src/Startup/Startup.vala"
	_tmp9_ = drop_target;
#line 37 "../src/Startup/Startup.vala"
	_tmp10_ = _g_object_ref0 ((GtkEventController*) _tmp9_);
#line 37 "../src/Startup/Startup.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp8_, _tmp10_);
#line 39 "../src/Startup/Startup.vala"
	_tmp11_ = self->priv->list;
#line 39 "../src/Startup/Startup.vala"
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
#line 39 "../src/Startup/Startup.vala"
	_tmp13_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 39 "../src/Startup/Startup.vala"
	gtk_scrolled_window_set_child (_tmp13_, _tmp12_);
#line 39 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp12_);
#line 39 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp13_);
#line 39 "../src/Startup/Startup.vala"
	scrolled = _tmp13_;
#line 43 "../src/Startup/Startup.vala"
	_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 43 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp14_);
#line 43 "../src/Startup/Startup.vala"
	add_button_box = _tmp14_;
#line 44 "../src/Startup/Startup.vala"
	_tmp15_ = add_button_box;
#line 44 "../src/Startup/Startup.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("application-add-symbolic");
#line 44 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp16_);
#line 44 "../src/Startup/Startup.vala"
	_tmp17_ = _tmp16_;
#line 44 "../src/Startup/Startup.vala"
	gtk_box_append (_tmp15_, (GtkWidget*) _tmp17_);
#line 44 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp17_);
#line 45 "../src/Startup/Startup.vala"
	_tmp18_ = add_button_box;
#line 45 "../src/Startup/Startup.vala"
	_tmp19_ = (GtkLabel*) gtk_label_new (_ ("Add Startup App…"));
#line 45 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp19_);
#line 45 "../src/Startup/Startup.vala"
	_tmp20_ = _tmp19_;
#line 45 "../src/Startup/Startup.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp20_);
#line 45 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp20_);
#line 47 "../src/Startup/Startup.vala"
	_tmp21_ = add_button_box;
#line 47 "../src/Startup/Startup.vala"
	_tmp22_ = _g_object_ref0 ((GtkWidget*) _tmp21_);
#line 47 "../src/Startup/Startup.vala"
	_tmp23_ = (GtkButton*) gtk_button_new ();
#line 47 "../src/Startup/Startup.vala"
	gtk_button_set_child (_tmp23_, _tmp22_);
#line 47 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp22_);
#line 47 "../src/Startup/Startup.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, 3);
#line 47 "../src/Startup/Startup.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp23_, 3);
#line 47 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp23_);
#line 47 "../src/Startup/Startup.vala"
	add_button = _tmp23_;
#line 52 "../src/Startup/Startup.vala"
	_tmp24_ = add_button;
#line 52 "../src/Startup/Startup.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp24_, GRANITE_STYLE_CLASS_FLAT);
#line 54 "../src/Startup/Startup.vala"
	_tmp25_ = (GtkActionBar*) gtk_action_bar_new ();
#line 54 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp25_);
#line 54 "../src/Startup/Startup.vala"
	actionbar = _tmp25_;
#line 55 "../src/Startup/Startup.vala"
	_tmp26_ = actionbar;
#line 55 "../src/Startup/Startup.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, GRANITE_STYLE_CLASS_FLAT);
#line 56 "../src/Startup/Startup.vala"
	_tmp27_ = actionbar;
#line 56 "../src/Startup/Startup.vala"
	_tmp28_ = add_button;
#line 56 "../src/Startup/Startup.vala"
	gtk_action_bar_pack_start (_tmp27_, (GtkWidget*) _tmp28_);
#line 58 "../src/Startup/Startup.vala"
	_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 58 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp29_);
#line 58 "../src/Startup/Startup.vala"
	box = _tmp29_;
#line 59 "../src/Startup/Startup.vala"
	_tmp30_ = box;
#line 59 "../src/Startup/Startup.vala"
	_tmp31_ = scrolled;
#line 59 "../src/Startup/Startup.vala"
	gtk_box_append (_tmp30_, (GtkWidget*) _tmp31_);
#line 60 "../src/Startup/Startup.vala"
	_tmp32_ = box;
#line 60 "../src/Startup/Startup.vala"
	_tmp33_ = actionbar;
#line 60 "../src/Startup/Startup.vala"
	gtk_box_append (_tmp32_, (GtkWidget*) _tmp33_);
#line 62 "../src/Startup/Startup.vala"
	_tmp34_ = box;
#line 62 "../src/Startup/Startup.vala"
	_tmp35_ = _g_object_ref0 ((GtkWidget*) _tmp34_);
#line 62 "../src/Startup/Startup.vala"
	_tmp36_ = (GtkFrame*) gtk_frame_new (NULL);
#line 62 "../src/Startup/Startup.vala"
	gtk_frame_set_child (_tmp36_, _tmp35_);
#line 62 "../src/Startup/Startup.vala"
	_g_object_unref0 (_tmp35_);
#line 62 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp36_);
#line 62 "../src/Startup/Startup.vala"
	frame = _tmp36_;
#line 66 "../src/Startup/Startup.vala"
	_tmp37_ = frame;
#line 66 "../src/Startup/Startup.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp37_);
#line 67 "../src/Startup/Startup.vala"
	switchboard_settings_page_set_show_end_title_buttons ((SwitchboardSettingsPage*) self, TRUE);
#line 69 "../src/Startup/Startup.vala"
	_tmp38_ = startup_widgets_app_chooser_new ();
#line 69 "../src/Startup/Startup.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp38_, TRUE);
#line 69 "../src/Startup/Startup.vala"
	g_object_ref_sink (_tmp38_);
#line 69 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->app_chooser);
#line 69 "../src/Startup/Startup.vala"
	self->priv->app_chooser = _tmp38_;
#line 73 "../src/Startup/Startup.vala"
	_tmp39_ = startup_backend_monitor_new ();
#line 73 "../src/Startup/Startup.vala"
	monitor = _tmp39_;
#line 74 "../src/Startup/Startup.vala"
	_tmp40_ = startup_controller_new (self);
#line 74 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->controller);
#line 74 "../src/Startup/Startup.vala"
	self->priv->controller = _tmp40_;
#line 76 "../src/Startup/Startup.vala"
	_tmp41_ = add_button;
#line 76 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp41_, "clicked", (GCallback) __startup_plug___lambda26__gtk_button_clicked, self, 0);
#line 82 "../src/Startup/Startup.vala"
	_tmp42_ = self->priv->app_chooser;
#line 82 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp42_, "app-chosen", (GCallback) __startup_plug___lambda27__startup_widgets_app_chooser_app_chosen, self, 0);
#line 86 "../src/Startup/Startup.vala"
	_tmp43_ = self->priv->app_chooser;
#line 86 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp43_, "custom-command-chosen", (GCallback) __startup_plug___lambda28__startup_widgets_app_chooser_custom_command_chosen, self, 0);
#line 90 "../src/Startup/Startup.vala"
	_tmp44_ = drop_target;
#line 90 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp44_, "drop", (GCallback) _startup_plug_on_drag_data_received_gtk_drop_target_drop, self, 0);
#line 92 "../src/Startup/Startup.vala"
	_tmp45_ = monitor;
#line 92 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp45_, "file-created", (GCallback) __startup_plug___lambda29__startup_backend_monitor_file_created, self, 0);
#line 96 "../src/Startup/Startup.vala"
	_tmp46_ = monitor;
#line 96 "../src/Startup/Startup.vala"
	g_signal_connect_object (_tmp46_, "file-deleted", (GCallback) __startup_plug___lambda30__startup_backend_monitor_file_deleted, self, 0);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (monitor);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (frame);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (box);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (actionbar);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (add_button);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (add_button_box);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (scrolled);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (drop_target);
#line 21 "../src/Startup/Startup.vala"
	_g_object_unref0 (empty_alert);
#line 21 "../src/Startup/Startup.vala"
	return obj;
#line 1224 "Startup.c"
}

static void
startup_plug_class_init (StartupPlugClass * klass,
                         gpointer klass_data)
{
#line 9 "../src/Startup/Startup.vala"
	startup_plug_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/Startup/Startup.vala"
	g_type_class_adjust_private_offset (klass, &StartupPlug_private_offset);
#line 9 "../src/Startup/Startup.vala"
	G_OBJECT_CLASS (klass)->constructor = startup_plug_constructor;
#line 9 "../src/Startup/Startup.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_plug_finalize;
#line 1239 "Startup.c"
}

static void
startup_plug_instance_init (StartupPlug * self,
                            gpointer klass)
{
#line 9 "../src/Startup/Startup.vala"
	self->priv = startup_plug_get_instance_private (self);
#line 1248 "Startup.c"
}

static void
startup_plug_finalize (GObject * obj)
{
	StartupPlug * self;
#line 9 "../src/Startup/Startup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_PLUG, StartupPlug);
#line 10 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->controller);
#line 11 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->list);
#line 12 "../src/Startup/Startup.vala"
	_g_object_unref0 (self->priv->app_chooser);
#line 9 "../src/Startup/Startup.vala"
	G_OBJECT_CLASS (startup_plug_parent_class)->finalize (obj);
#line 1265 "Startup.c"
}

static GType
startup_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StartupPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupPlug), 0, (GInstanceInitFunc) startup_plug_instance_init, NULL };
	GType startup_plug_type_id;
	startup_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "StartupPlug", &g_define_type_info, 0);
	StartupPlug_private_offset = g_type_add_instance_private (startup_plug_type_id, sizeof (StartupPlugPrivate));
	return startup_plug_type_id;
}

GType
startup_plug_get_type (void)
{
	static volatile gsize startup_plug_type_id__once = 0;
	if (g_once_init_enter (&startup_plug_type_id__once)) {
		GType startup_plug_type_id;
		startup_plug_type_id = startup_plug_get_type_once ();
		g_once_init_leave (&startup_plug_type_id__once, startup_plug_type_id);
	}
	return startup_plug_type_id__once;
}

